import { IDType, DataObject, NewData, RESTClient } from './utility';
export declare abstract class BaseModel {
    accessor downloading: number;
    accessor uploading: number;
    clear(): void;
}
/**
 * This basic class is a middle class, which isn't for direct using
 */
export declare abstract class BaseListModel<D extends DataObject> extends BaseModel {
    abstract client: RESTClient;
    abstract baseURI: string;
    indexKey: keyof D;
    accessor currentOne: D;
    static createNested(parentId: IDType): BaseListModel<{}>;
    clearCurrent(): void;
    clear(): void;
    updateOne(data: Partial<NewData<D>>, id?: IDType): Promise<D>;
    getOne(id: IDType): Promise<D>;
    deleteOne(id: IDType): Promise<void>;
}
