import { TypeKeys } from 'web-utility';
import { BaseModel } from '../Base';
export declare function toggle<T extends BaseModel>(property: TypeKeys<T, boolean | number>): (origin: (...data: any[]) => Promise<any>, {}: ClassMethodDecoratorContext) => (this: T, ...data: any[]) => Promise<any>;
export declare function toggleNotification<T extends BaseModel>(message: string | ((instance: T) => string)): (origin: (...data: any[]) => Promise<any>, {}: ClassMemberDecoratorContext) => (this: T, ...data: any[]) => Promise<any>;
interface PersistMeta<V = any, S = any> {
    key: string;
    set?: (value: V) => S;
    get?: (value?: S) => V;
}
export declare function persist<T, V, S>(patcher?: Omit<PersistMeta<V, S>, 'key'>): ({}: ClassAccessorDecoratorTarget<T, V>, { name, addInitializer }: ClassAccessorDecoratorContext<T, V>) => void;
export declare function restore<T extends object>(classInstance: T, storeKey: string): Promise<void>;
export declare function destroy<T extends object>(classInstance: T, storeKey: string): Promise<void>;
export {};
